Index: NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg.F90
===================================================================
--- NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg.F90	(revision 13103)
+++ NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg.F90	(revision 13105)
@@ -88,5 +88,5 @@
       CASE( np_rhgEAP )                ! Elasto-Anisotropic-Plastic !
          !                             !----------------------------!
-         CALL ice_dyn_rhg_eap( kt, stress1_i, stress2_i, stress12_i, shear_i, divu_i, delta_i, aniso_11, aniso_12 )
+         CALL ice_dyn_rhg_eap( kt, stress1_i, stress2_i, stress12_i, shear_i, divu_i, delta_i, aniso_11, aniso_12, rdg_conv )
       END SELECT
       !
Index: NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg_eap.F90
===================================================================
--- NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg_eap.F90	(revision 13103)
+++ NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg_eap.F90	(revision 13105)
@@ -67,5 +67,5 @@
 CONTAINS
 
-   SUBROUTINE ice_dyn_rhg_eap( kt, pstress1_i, pstress2_i, pstress12_i, pshear_i, pdivu_i, pdelta_i, paniso_11, paniso_12 )
+   SUBROUTINE ice_dyn_rhg_eap( kt, pstress1_i, pstress2_i, pstress12_i, pshear_i, pdivu_i, pdelta_i, paniso_11, paniso_12, prdg_conv )
       !!-------------------------------------------------------------------
       !!                 ***  SUBROUTINE ice_dyn_rhg_eap  ***
@@ -123,4 +123,5 @@
       REAL(wp), DIMENSION(:,:), INTENT(  out) ::   pshear_i  , pdivu_i   , pdelta_i      !
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   paniso_11 , paniso_12                 ! structure tensor components
+      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   prdg_conv                             ! for ridging
       !!
       INTEGER ::   ji, jj       ! dummy loop indices
@@ -415,5 +416,5 @@
                   yield22(ji,jj) = 0.5_wp * (stressptmp - stressmtmp)
                   yield12(ji,jj) = stress12tmp(ji,jj)
-                  rdg_conv(ji,jj) = -min( alphar, 0._wp)    
+                  prdg_conv(ji,jj) = -min( alphar, 0._wp)    
                ENDIF
 
@@ -443,5 +444,5 @@
          END DO
          !CALL lbc_lnk( 'icedyn_rhg_eap', zp_delt, 'T', 1. )
-         CALL lbc_lnk_multi( 'icedyn_rhg_eap', stress12tmp, 'T', 1., rdg_conv, 'T', 1. )
+         CALL lbc_lnk( 'icedyn_rhg_eap', stress12tmp, 'T', 1. )
 
          DO jj = 1, jpjm1
@@ -717,4 +718,6 @@
       !                                                   ! ==================== !
       !
+      CALL lbc_lnk( 'icedyn_rhg_eap', prdg_conv, 'T', 1. )  ! only need this in ridging module after rheology completed
+      !
       !------------------------------------------------------------------------------!
       ! 4) Recompute delta, shear and div (inputs for mechanical redistribution) 
@@ -838,4 +841,7 @@
       ! --- yieldcurve --- !
       IF( iom_use('yield11') .OR. iom_use('yield12') .OR. iom_use('yield22')) THEN
+
+         CALL lbc_lnk_multi( 'icedyn_rhg_eap', yield11, 'T', 1., yield22, 'T', 1., yield12, 'T', 1. )
+
          CALL iom_put( 'yield11', yield11 * zmsk00 )
          CALL iom_put( 'yield22', yield22 * zmsk00 )
@@ -844,5 +850,6 @@
 
       ! --- anisotropy tensor --- !
-      IF( iom_use('aniso') ) THEN
+      IF( iom_use('aniso') ) THEN       
+         CALL lbc_lnk( 'icedyn_rhg_eap', aniso_11, 'T', 1. ) 
          CALL iom_put( 'aniso' , aniso_11 * zmsk00 )
       ENDIF
Index: NEMO/branches/2019/dev_r11842_SI3-10_EAP/tests/ICE_ADV2D/EXPREF/namelist_ice_cfg
===================================================================
--- NEMO/branches/2019/dev_r11842_SI3-10_EAP/tests/ICE_ADV2D/EXPREF/namelist_ice_cfg	(revision 13103)
+++ NEMO/branches/2019/dev_r11842_SI3-10_EAP/tests/ICE_ADV2D/EXPREF/namelist_ice_cfg	(revision 13105)
@@ -50,6 +50,6 @@
 &namdyn_adv     !   Ice advection
 !------------------------------------------------------------------------------
-   ln_adv_Pra       = .true.         !  Advection scheme (Prather)
-   ln_adv_UMx       = .false.          !  Advection scheme (Ultimate-Macho)
+   ln_adv_Pra       = .false.         !  Advection scheme (Prather)
+   ln_adv_UMx       = .true.          !  Advection scheme (Ultimate-Macho)
       nn_UMx        =   5             !     order of the scheme for UMx (1-5 ; 20=centered 2nd order)
 /